﻿using AlgorithmByCSharp.AStarSearch;
using AlgorithmByCSharp.GetRedPacket;
using AlgorithmByCSharp.LeastRecentlyUsed;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AlgorithmByCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            //LineGetRedPacket();
            //DivideRedPacket();
            //LRU();
            AStarSearch();
        }

        static void AStarSearch()
        {
            //设置起点和终点
            Grid starGrid = new Grid(2, 1);
            Grid endGrid = new Grid(2, 5);

            AStarPathFinding aStarPathFinding = new AStarPathFinding();
            //搜索迷宫终点
            Grid resultGrid = aStarPathFinding.AStarSearch(starGrid, endGrid);
            //回溯迷宫路径
            List<Grid> path = new List<Grid>();
            while (resultGrid != null)
            {
                path.Add(new Grid(resultGrid.x, resultGrid.y));
                resultGrid = resultGrid.parent;
            }
            //输出迷宫和路径，路径用*表示
            for (int i = 0; i < aStarPathFinding.MAZE.GetLength(0); i++)
            {
                for (int j = 0; j < aStarPathFinding.MAZE.GetLength(1); j++)
                {
                    if (aStarPathFinding.ContainGrid(path, i, j))
                        Console.Write("*, ");
                    else
                        Console.Write(aStarPathFinding.MAZE[i, j] + ", ");
                }
                Console.WriteLine();
            }
        }

        static void LRU()
        {
            LRUCache lRUCache = new LRUCache(5);
            lRUCache.Put("001", "User1 - Message");
            lRUCache.Put("002", "User2 - Message");
            lRUCache.Put("003", "User3 - Message");
            lRUCache.Put("004", "User4 - Message");
            lRUCache.Put("005", "User5 - Message");
            lRUCache.Get("001");
            lRUCache.Put("004", "User4 - NewMessage");
            lRUCache.Put("006", "User6 - UpdateMessage");
            Console.WriteLine(lRUCache.Get("001"));
            Console.WriteLine(lRUCache.Get("002"));
            Console.WriteLine(lRUCache.Get("006"));
        }

        static void DivideRedPacket()
        {
            float money_YUAN = 10.00f;
            int peopleNum = 10;
            DivideRedPacket packet = new DivideRedPacket();
            Queue moneyList_YUAN = packet.DividePacket(money_YUAN, peopleNum);
            for (int i = 0; i < peopleNum; i++)
            {
                var value = moneyList_YUAN.Dequeue();
                Console.WriteLine(value);
            }
        }

        static void LineGetRedPacket()
        {
            int money_YUAN = 10;
            int peopleNum = 10;
            CutLineRedPacket packet = new CutLineRedPacket();
            Queue moneyList_YUAN = packet.CutLineGetRedPacket(money_YUAN, peopleNum);
            for (int i = 0; i < peopleNum; i++)
            {
                var value = moneyList_YUAN.Dequeue();
                Console.WriteLine(value);
            }
        }
    }
}
